module Admin::PersonalResearchesHelper

	def get_paper_list
		user = current_user.nil? ? OrbitHelper.current_user : current_user
	  user_profile = user.member_profile
	  researchs = Research.where(:member_profile_id => user_profile.id)
	  researchs = researchs.collect do |r|
	      files = r.research_files.collect do |rf|
	          {
	              "title" => rf.title,
	              "description" => rf.description,
	              "link" => rf.file.url,
	              "extension" => (rf.file.url.split(".").last rescue "")
	          }
	      end

	      {
	          "id" => r.id.to_s,
	          "edit_url" => "/#{I18n.locale.to_s}/admin/members/#{user_profile.to_param}/researchs/#{r.to_param}/edit",
	          "delete_url" => "/#{I18n.locale.to_s}/admin/researchs/#{r.id.to_s}",
	          "paper_title" => r.research_title,
	          "keywords" => r.keywords,
	          "files" => files
	      }
	  end
	  researchs
	end

	def import_this_research(row,mp)
		value = nil
	  	research = Research.new
	  	row.cells.each_with_index do |cell,index|
	  		next if index < 2
	  		next if cell.nil?
	  		val = cell.value
	  		next if val.nil? || val == ""
	  		case index
	  		when 2
	  			value = {"en" => val}
	  		when 3
	  			begin
	  				value["zh_tw"] = val 
	  			rescue 
	  				value = {"zh_tw" => val}
	  			end
	  			research.research_title_translations = value
	  		when 4
	  			value = {"en" => val}
	  		when 5
	  			begin
	  				value["zh_tw"] = val 
	  			rescue 
	  				value = {"zh_tw" => val}
	  			end
	  			research.extracted_chapters_translations = value
	  		when 6
	  			value = {"en" => val}
	  		when 7
	  			begin
	  				value["zh_tw"] = val 
	  			rescue 
	  				value = {"zh_tw" => val}
	  			end
	  			research.authors_translations = value
	  		when 8
	  			research.year = val
	  		when 9
	  			research.language = val
	  		when 10
	  			research.publish_date = val
	  		when 11
	  			research.url = val
	  		when 12
	  			research.keywords = val
	  		when 13
	  			research.note = val
	  		end
	  	end
	  	research.member_profile = mp
	  	research.save
	end
	def get_data_for_excel(year_start,year_end)
	    data = []
	    roles = Role.where(:disabled => false, :title.ne => "", :title.ne => nil).asc(:key)
	    roles.each do |role|
	      d = {}
	      d["name"] = role.title
	      mps = role.member_profile_ids
	      # d1 = DateTime.new(year_start,1,1,0,0)
	      # d2 = DateTime.new(year_end,12,31,23,59)   
	      d["data"] = Research.where(:year.gte => year_start.to_s, :year.lte => year_end.to_s, :member_profile_id.in => mps) rescue []
	      data << d
	    end
	    return data
	end

  	def get_chart_data(year_start,year_end,role,type)
	    case type
	    when "category"
	      jls = ResearchCategory.all
	    end

	    finaldata = []
	    role = Role.find(role) rescue nil
	    mps = []
	    if !role.nil?
	       mps = role.member_profile_ids
	    end
	    jls.each do |jl|
	      data = {}
	      data["name"] = jl.title
	      data["data"] = {}
	      (year_start..year_end).each do |year|
	        # d1 = DateTime.new(year,1,1,0,0)
	        # d2 = DateTime.new(year,12,31,23,59)   
	        t = jl.researches.where(:year => year.to_s, :member_profile_id.in => mps).count rescue 0
	        data["data"][year.to_s] = t
	      end
	      finaldata << data
	    end
	    data = {"name" => "N/A", "data" => {}}
	    (year_start..year_end).each do |year|
	      # d1 = DateTime.new(year,1,1,0,0)
	      # d2 = DateTime.new(year,12,31,23,59)
	      case type
	      when "category"
	         t = Research.where(:year => year.to_s, :member_profile_id.in => mps, :project_type_id => nil).count rescue 0
	      end
	     
	      data["data"][year.to_s] = t
	    end
	    finaldata << data
	    finaldata
	 end
end