Rails.application.routes.draw do
	locales = Site.find_by(site_active: true).in_use_locales rescue I18n.available_locales
	scope "(:locale)", locale: Regexp.new(locales.join("|")) do
		namespace :admin do
      get 'research_setting' => "researchs#setting"
      get 'researchs/download_excel_format' => 'researchs#excel_format'
      post 'researchs/import_from_excel' => 'researchs#import_from_excel'

      resources :researchs do
        collection do
          get 'toggle_hide' => 'researchs#toggle_hide'
          get 'analysis'
          get 'analysis_report'
          get "download_excel"
        end
      end

      resources :members do
        collection do
          scope '(:name-:uid)' do
            resources :researchs do
              collection do
                get 'frontend_setting' => 'researchs#frontend_setting'
                post 'update_frontend_setting' => 'researchs#update_frontend_setting'
              end
            end
          end
        end
      end

      resources :research_categories
      post "research_categories/update_order" => "research_categories#update_order"
		end
	end
end
